
/*
 *
 *	Stripped (XPDS, T9, COFF only) crt0.c.
 *
 *	BASED ON: @(#)startup.c	1.35	94/05/10	(c) PACT
 *
 *	Copyright (c) 1991-1994 PACT
 *	All Rights Reserved
 *
 *	This copy is for private circulation only and may not be used
 *	in any other manner.
 *
 *	C runtime entry (startup) code.  Run as user process after network has
 *	been loaded, sets up C runtime environment before calling main().
 *
 */

#include	<stdio.h>
#include	<asm.h>
#include	<par.h>
#include	<node.h>
#include	<stdlib.h>
#include	<string.h>
#include	<setjmp.h>
#include	<sys/times.h>


/* No stack checking, of course.										*/
#pragma	PACT stackcheck off

#define MAX_COMMAND_LINE_LENGTH	512
#define MAX_STRING_LENGTH	256
#define MAXARG			50

/* A bool is an int.													*/
typedef	int				bool_t;
#define	FALSE			0
#define	TRUE			1

#ifndef	_C_Entry
#	define	_C_Entry	_CRT_enter
#endif



#define iswhitespace(ch) ((ch == ' ') || (ch == '\t') || (ch == '\0') || (ch == '\n'))

/*
 *
 *		void _C_Entry2 (struct _Process *proc)
 *
 *	This function is called by _C_Entry with a proper GP and PD.  It sets
 *	up the runtime environment and calls main().
 *
 */

int	_CRT_enter ( struct _Node *_NodeInfo, int DebugFlag )
{
	/* Declare some functions and vars used: memory manager, file		*/
	/* system, debugger etc.											*/
	extern	void	*_mdesc, *__minit (void *heap, int heapsize);
	extern	void	_finit (void);
	extern	int		*_dbginit (void *code, void *data);
	extern	int		main (int argc, char *argv[], char *envp[]);

	/* Some functions use different linkage.							*/
	struct _Process *proc = _NodeInfo->process;
	int ret;
	long length;
	char *DebugCommand;
	int argc; char **argv; char **envp;

	_Node = *_NodeInfo;

#	pragma	PACT	linkage tcc	__minit

	/* Init memory manager.  Gets heap.									*/
	_mdesc = __minit (proc->heap, proc->heapsize);

	/* Store pointer to start of Processor structure at start of 		*/
	/* memory, for debugging purposes.									*/
	((struct _Processor **) _Node.memstart) [0] = proc->processor;

	/* If not reduced, get host info, init filesystem and get cl args.	*/
/*	_serverid ();		940803,REHK: causes hangs later on! */
	_finit ();

	/* Setup longjmp env for tasks that want to return to the system	*/
	/* process that started them instead of stopping.					*/
/*	if (setjmp (_taskreturn_env) == 0)		*/

#ifdef GDBINIT
	if ( DebugFlag ){
	/* This should be the first communication to server
	*/
		ChanIn( _Node.fromserver, &length, sizeof(long));
		DebugCommand = (char *)malloc(length *sizeof(char));
		ChanIn( _Node.fromserver, DebugCommand, length );
	}
#endif
#ifdef GDBINIT
	SetArgcArgv( &argc, &argv );
	if ( DebugFlag )
		debug_init( DebugCommand, argv[0] );
#endif
	envp = NULL;
	ret = main (argc, argv, envp);
#ifdef GDBINIT
	if ( DebugFlag )
		debug_exit();
#endif
	Exit(ret);
}

Exit( int retval )
{
	_LIBC_exit();
	_exit( retval );
}

#ifdef GDBINIT
void exit( int retval )
{
	debug_exit();
	Exit( retval );
}
#endif

static char *copystr(str)
char *str;
{
   char  *new;
   
   new = malloc(strlen(str)+1);
   if (new == NULL)
      return NULL;

   strcpy(new, str);
   
   return new;
}

#ifdef GDBINIT
static char argstr[MAX_COMMAND_LINE_LENGTH+2];
static char tempStr[MAX_STRING_LENGTH];
int SetArgcArgv(int *ArgcPtr, char **ArgvPtr[])
{
   static char *argv[MAXARG];
   int argc = 0;
   int i, j;
   int removed = 0;
   char *lp;
   char red,*rfname;
   char err;

   GetArgs( argstr );
   if (strlen(argstr) > MAX_STRING_LENGTH)
      return -1;
   argstr[strlen(argstr)+1] = '\0';
      
   lp = argstr;
   
   while (*lp)
   {
      /* find first character of this argument */
      while (iswhitespace(*lp))
         lp++;
         
      err = ' ';

      /* Check for I/O redirectors */
      if ((*lp == '<') || (*lp == '>')) {
         red = *lp++;
         if ((red == '>') && (*lp == '&'))
            err = *lp++;
            
         while (iswhitespace(*lp))
            lp++;
         
         rfname = lp;
         /* find the end of this argument */
         while (!iswhitespace(*lp))
            lp++;
         *lp++ = '\0';
         
      }
      else {
         /* Is it quoted ? */
         if (*lp == '"') {
            argv[argc++] = ++lp;
            
            /* Find the rest of the argument */
            while ((*lp != '"') && (*lp != '\0'))
               lp++;
         }
         else {
            argv[argc++] = lp;

            /* find the end of this argument */
            while (!iswhitespace(*lp))
               lp++;
         }

         *lp++ = '\0';
      }
   }
   
   for (i=0; i<argc; i++){
      strcpy( tempStr, argv[i] );
      for ( j = 0; j < strlen(tempStr); j++ )
         tempStr[j] = tolower(tempStr[j]);
      if (( strcmp( tempStr, "-d" ) == 0 )||
          ( strcmp( tempStr, "-heap" ) == 0 )||
          ( strcmp( tempStr, "-stack" ) == 0 )){
             for ( j = i+2; j <argc; j++ )
                argv[j-2] = argv[j];
             argc -= 2; 
             if ( i == argc) break;
             i -= 1;
      }
            
   }

   *ArgcPtr =  argc;
   *ArgvPtr = (char **)malloc( argc * sizeof(char *));
   for (i=0; i<argc; i++)
      (*ArgvPtr)[i] = copystr(argv[i]);
}
#endif



