/*{{{  includes and globs*/
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <fcntl.h>
#include <netdb.h>
#include <stdio.h>
#include <errno.h>

char message[]="stop";
/*}}}*/
main(argc,argv)
   int argc; char *argv[];
   {
   /*{{{  defs*/
   int i, sock, NoWrites=1, MessLen, Fd, Written, TotWrite=0;
   struct sockaddr_in server;
   struct hostent *hp;
   char buff[10240];
   /*}}}*/

   /*{{{  setup*/
   if (argc<2) { fprintf(stderr,"no host name\n"); exit(1); }
   if (argc<3) { fprintf(stderr,"no port address\n"); exit(1); }
   sock=socket(AF_INET,SOCK_STREAM,0);
   if (sock<0) { perror("opening stream socket"); exit(1); }
   server.sin_family = AF_INET;
   hp=gethostbyname(argv[1]);
   if (hp==0)
      {
      fprintf(stderr,"%s: unknown host\n",argv[1]);
      exit(2);
      }
   bcopy(hp->h_addr,&server.sin_addr,hp->h_length);
   server.sin_port=htons(atoi(argv[2]));
   if (argc>3) strcpy(buff,argv[3]);
   else        strcpy(buff,message);
   MessLen=strlen(buff)+1;
   if (argc>4) NoWrites=atoi(argv[4]);
   /*}}}*/
   /*{{{  connect socket, set non-blocking*/
   if (connect(sock,&server,sizeof(server))<0)
      {
      perror("connecting stream socket");
      exit(1);
      }
   if (fcntl(sock,F_SETFL,FNONBIO)<0) { perror("fcntl"); exit(1); }
   /*}}}*/
   printf("About to do %d fast writes\n",NoWrites);
   for(i=0;i<NoWrites;i++)
     {
       if ((Written=write(sock,buff,MessLen))<0)
          fprintf(stderr,"Error writing stream socket, errno=%d\n",errno);
       else TotWrite+=Written;
     }
   close(sock);
   printf("Wrote total of %d bytes, from an expected %d\n",TotWrite,MessLen*NoWrites);
   }
