.so man.macros
.HS run tk 
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
run \- Execute an in\-built function
.SH SYNOPSIS
\fBrun \fIfunction\fR ?\fIparameters\fR?
.BE

.SH DESCRIPTION
.PP
This command supports the execution of some in\-built functions. The
return value of this command is the value returned by the function.

.SH FUNCTIONS
.IP "\fBvcpinit \fIlink\fR"
Initialize virtual VCP on the specified physical link. \fIlink\fR is the link number
preceded by the character l. Raw channel IO cannot be used on the link after
VCP has been initialized. \fIvcpsend\fR and \fIvcprecv\fR can be used to
send or receive messages on any virtual channel mapped to this physical link.
This function returns success/failure.
.IP "\fBvcpquit \fIlink\fR"
Terminate the virtual VCP on \fIlink\fR. 
.IP "\fBlocalwrite \fIaddress value\fR"
Write the hexadecimal byte specified by \fIvalue\fR at \fIaddress\fR.
.IP "\fBservinit \fIchan\fR ?\fB\-window \fIwincmd\fR? ?\fB\-bind \fIcommand\fR? \fIparameters\fR"
.IP "\fBcoffserver \fIchan\fR ?\fB\-window \fIwincmd\fR? ?\fB\-bind \fIcommand\fR? \fIparameters\fR"
Run iserver or coffserver on the virtual or physical link specified by \fIchan\fR. Physical
links are specified by the link number preceded by l. Virtual links are
specified by the four tuple \fIoutheader outvchan invchan inheader\fR.
Server requests are received on the virtual channel \fIinvchan\fR and 
acknowledgement is sent to \fIinheader\fR. Reply packets are sent to the
virtual channel address \fIoutheader\fR and acknowledgement is expected at
\fIoutvchan\fR.  \fIoutheader\fR and \fIinheader\fR have the format 
\fIlink\fR?.\fIsubheader\fR. ...?\fIsubheader\fR. Each subheader is 
a decimal number and is assumed to be 16\-bit if its value is greater than
255 or if it starts with 0. Otherwise it is assumed to be 8\-bit.
\fIoutvchan\fR and \fIinvchan\fR have the format \fIlink\fR.\fIsubheader\fR. 
If the \fB\-window\fR option is specified, the shell command specified by
\fIwincmd\fR is executed to create a window, and all standard IO is redirected to
the window. A typical window command uses an xterm running telnet. The 
parameters to telnet can be specified using the variables \fI%host\fR and
\fI%port\fR. These will be set to appropriate values before \fIwincmd\fR is
executed. If the server is to run in non\-blocking mode, \fB\-bind\fR option
should be specified. The Tcl/Tk command specified by \fIcommand\fR will be
executed when the program has terminated. \fIparameters\fR specifies the 
parameters to the server as well as those of the application. It has the
same format as iserver parameters  and all parameters that do not belong to the server are passed to 
the application program. This function returns \fIserverid\fR, which can be used
to terminate the server, if required.
.IP "\fIservquit \fIserverid\fR"
Terminate the server specified by \fIserverid\fR. \fIserverid\fR 
should be the value returned by a \fIservinit\fR or \fIcoffserver\fR call.




