.so man.macros
.HS vcpsend tk 
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
vcpsend \- Send a message over a virtual/physical channel
.SH SYNOPSIS
\fBvcpsend \fIheader vchan\fR ?\fIoptions\fR?
.PP
\fBvcpsend \fIlink\fR ?\fIoptions\fR?
.BE

.SH OPTIONS
.IP "\fB\-data \fIdata\fR" 15
Data is provided in the Tcl variable \fIdata\fR in the form of a string. The
format for specifying data is \fIelement\fR?.\fIelement\fR.\fI ... element\fR? .
Each element in this string is assumed to be 32\-bit if it ends in the
character l, 16\-bit if it ends in s, and 8\-bit otherwise. 
Hexadecimal numbers should be preceded by 0x and octal numbers by the
digit 0.
.IP "\fB\-file \fIfilename\fR" 15
Data to be transmitted is in the file specified by \fIfilename\fR.
.IP "\fB\-bind \fIcommand\fR" 15
Perform a non\-blocking send and execute the Tcl/Tk command specified in 
\fIcommand\fR when the send is complete.
.IP "\fB\-timeout \fItime command\fR" 15
If the send cannot be completed in the number of microseconds specified by
\fItime\fR, abort the send command and execute the Tcl/Tk command specified
by \fIcommand\fR.

.SH DESCRIPTION
.PP
This command is used to send a message over a virtual channel or a
physical link. When a message is to be sent to a virtual channel,
\fIheader\fR specifies the virtual channel address of the destination. It is
of the form \fIlink\fR.\fIsubheader\fR?.\fIsubheader ...\fR? . Each of the
subheaders is a decimal number, and is assumed to be a two\-byte header,
if its value is greater than 255 or if it starts with a zero. Otherwise, it
is assumed to be a single\-byte header. \fIlink\fR can take values
l0, l1, l2 and l3.  \fIvchan\fR specifies the virtual
channel address where the acknowledgement is expected. It has the format
?\fIlink\fR.?\fIsubheader\fR . The message is packetized and sent in
the format required by C100. The command is complete only when the
acknowledgement of the last packet is received. Virtual VCP should be
initialized by running \fIvcpinit\fR on \fIlink\fR before this call is made.
.PP
When a message is to be sent over a physical channel, \fIlink\fR specifies
the linknumber on which the message should be sent. The command is complete
when the message has been successfully sent over the channel.
.SH SEE ALSO
run, vcprecv


