/*	Type definitions used by TCL and TCL-VCP interface routines
*/

#ifndef TCL_VCP_TYPE_H
#define	TCL_VCP_TYPE_H

#include "extype.h"

/*	Maximum size of data buffer
*/
#define	MAX_BUF_SIZE		1024


/*	Specification of source of send and destination of receive
*/
typedef struct file_or_buffer {
	Boolean FileFlag;	/* True if data is sent from/received in file */
	char *BufferPtr;	/* Filename or buffer address 		      */
}FILE_OR_BUFFER;


/*	Queue of message buffers
*/
typedef struct buffer_list {
	QUEUE_CHAIN	*qlink;	/* Next element in queue */
	int	BufferSize;	/* Size of this buffer	 */
	char 	*BufferPtr;	/* Pointer to data	 */
}BUFFER_LIST;

/*	Queue of tcl commands
*/
typedef struct {
	QUEUE_CHAIN 	*qlink;	/* Next command in queue */
	void 		*interp;/* Current interpreter   */
	char		*Command;/* Command to be executed */
}TCL_COMMAND;
	

#endif
